import browser from "webextension-polyfill";

console.log("Hello from the background!");

browser.runtime.onInstalled.addListener((details) => {
  console.log("Extension installed:", details);
  console.log("undefined",document);
});

browser.runtime.onMessage.addListener((message, sender, sendResponse) => {
  console.log("Got message", message);
  if (message.type === "fetch") {
    return ( async () => {
      const response = await fetch(message.url);
      if (!response.ok) {
        console.error(`Failed to fetch: ${response.statusText}`);
        throw new Error(`Failed to fetch: ${response.statusText}`);
      }
      if ( message.resType === "text" ) {
        const text = await response.text();
        return text;
      }
      else if ( message.resType === "json" ) {
        const json = await response.json();
        return json;
      }
      else if ( message.resType === "array" ) {
        const array = await response.arrayBuffer();
        return array;
      }
    })();
  }
});